------------------------------------------------------------------------
-- Some simple examples
------------------------------------------------------------------------

-- # import Explicit
-- # import TypeChecker

-- Short-hand for various variables.

v₀ (Γ : Ctxt) (τ : Ty Γ) : Γ ▻ τ ⊢ τ / wk τ
v₀ = var (vz _)

v₁ (Γ : Ctxt) (τ₁: Ty Γ) (τ₂: Ty _) : Γ ▻ τ₁ ▻ τ₂ ⊢ τ₁ / wk _ / wk _
v₁ = var (vs (vz _) _)

v₂ (Γ : Ctxt) (τ₁: Ty Γ) (τ₂: Ty _) (τ₃: Ty _)
  : Γ ▻ τ₁ ▻ τ₂ ▻ τ₃ ⊢ τ₁ / wk _ / wk _ / wk _
v₂ = var (vs (vs (vz _) _) _)

v₃ (Γ : Ctxt) (τ₁: Ty Γ) (τ₂: Ty _) (τ₃: Ty _) (τ₄: Ty _)
  : Γ ▻ τ₁ ▻ τ₂ ▻ τ₃ ▻ τ₄ ⊢ τ₁ / wk _ / wk _ / wk _ / wk _
v₃ = var (vs (vs (vs (vz _) _) _) _)

v₄ (Γ : Ctxt) (τ₁: Ty Γ) (τ₂: Ty _) (τ₃: Ty _) (τ₄: Ty _) (τ₅: Ty _)
  : Γ ▻ τ₁ ▻ τ₂ ▻ τ₃ ▻ τ₄ ▻ τ₅ ⊢ τ₁ / wk _ / wk _ / wk _ / wk _ / wk _
v₄ = var (vs (vs (vs (vs (vz _) _) _) _) _)

-- \x -> x

t₁ = λ (var (vz (✶ ε)))

-- (\x -> x) (\x -> x)

t₂ = (λ (var (vz _))) @ (λ (var (vz (✶ ε))))

-- List : Set -> Set

ListTy = Π (✶ ε) (✶ _)

-- nil : (a : Set) -> El (List a)

nilTy = Π (✶ (ε ▻ ListTy)) (El (v₁ {_} {ListTy} @ v₀ {_} {✶ _}))

-- cons : (a : Set) -> El a -> El (List a) -> El (List a)

consTy = Π (✶ (ε ▻ ListTy ▻ nilTy))
           (Π (El (v₀ {_} {✶ _}))
              (Π (El (v₃ {_} {ListTy} @ v₁ {_} {✶ _}))
                 (El (v₄ {_} {ListTy} @ v₂ {_} {✶ _}))
              )
           )

------------------------------------------------------------------------
-- Examples written as raw terms

-- \x -> x

t₁' = inferTm ε (λʳʷ ✶ʳʷ (varʳʷ vzʳʷ))

-- (\x -> x) (\x -> x)

t₂' = inferTm ε (λʳʷ (Πʳʷ ✶ʳʷ ✶ʳʷ) (varʳʷ vzʳʷ) @ʳʷ
                 λʳʷ ✶ʳʷ           (varʳʷ vzʳʷ))

-- List : Set -> Set

ListTy' = checkTy ε (Πʳʷ ✶ʳʷ ✶ʳʷ)

-- nil : (a : Set) -> El (List a)

nilTy' = checkTy (ε ▻ ListTy)
                 (Πʳʷ ✶ʳʷ (Elʳʷ (varʳʷ (vsʳʷ vzʳʷ) @ʳʷ varʳʷ vzʳʷ)))

Examples : Type
Examples = time-plugin(Examples, Set)
