------------------------------------------------------------------------
-- A bunch of substitution lemmas
------------------------------------------------------------------------

-- # import Explicit.Types
-- # import Explicit.Equivalence
-- # import Explicit.Extensional

------------------------------------------------------------------------
-- Some substitution congruences

-- wkCong and subCong are proved in IndicesEqual.

abstract

  wkCong' (Γ¹ : Ctxt) (σ¹ : Ty Γ¹)
          (Γ² : Ctxt) (σ² : Ty Γ²)
    : Γ¹ ≜ Γ² -> σ¹ ≛ σ² -> wk σ¹ ≘ wk σ²
  wkCong' {Γ¹} {σ¹} {Γ²} {σ²} eqΓ eqσ =
    extEqToSubstEq $
      extEq eqΓ (eqΓ ▻Cong eqσ)
            (\τ¹ v¹ τ² v² eqv ->
                betweenTm (substWk v¹ σ¹) (substWk v² σ²) $
                  varCong $ vsCong eqv eqσ)

  subCong' (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
           (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
    : Γ¹ ≜ Γ² -> τ¹ ≛ τ² -> t¹ ≈⊢ t² -> sub t¹ ≘ sub t²
  subCong' eqΓ₀ eqτ₀ eqt₀ =
    extEqToSubstEq $ extEq (eqΓ₀ ▻Cong eqτ₀) eqΓ₀ (proof eqt₀)
    where
    proof (Γ¹ : Ctxt) (τ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
          (Γ² : Ctxt) (τ² : Ty Γ²) (t² : Γ² ⊢ τ²)
      : t¹ ≈⊢ t² -> ExtEq (sub t¹) (sub t²)
    proof {Γ¹} {σ¹} {t¹} {Γ²} {σ²} {t²}
          eqt _ (vz σ¹) _ (vz σ²) (vzCong eqσ) =
      betweenTm (substVzSub σ¹ t¹) (substVzSub σ² t²) eqt
    proof {Γ¹} {σ¹} {t¹} {Γ²} {σ²} {t²}
          eqt _ (vs v¹ σ¹) _ (vs v² σ²) (vsCong eqv eqσ) =
      betweenTm (substVsSub v¹ σ¹ t¹) (substVsSub v² σ² t²) $
        varCong eqv
    proof {Γ¹} {σ¹} {t¹} {Γ²} {σ²} {t²}
          eqt _ (v¹ ∷≡∋ eqτ) _ v² (castVarEqˡ eqτ eqv) =
      substCastVar v¹ eqτ (sub t¹)
        `transTm`
      proof eqt _ v¹ _ v² eqv
    proof {Γ¹} {σ¹} {t¹} {Γ²} {σ²} {t²}
          eqt _ v¹ _ (v² ∷≡∋ eqτ) (castVarEqʳ eqτ eqv) =
      proof eqt _ v¹ _ v² eqv
        `transTm`
      symTm (substCastVar v² eqτ (sub t²))

mutual

  liftCong (Γ¹, Δ¹ : Ctxt) (σ¹ : Ty Γ¹) (ρ¹ : Subst Γ¹ Δ¹)
           (Γ², Δ² : Ctxt) (σ² : Ty Γ²) (ρ² : Subst Γ² Δ²)
    : ρ¹ ≘ ρ² -> σ¹ ≛ σ² -> ρ¹ ↑ σ¹ ≘ ρ² ↑ σ²
  liftCong eqρ₀ eqσ₀ =
    extEqToSubstEq $
      extEq (substEqCtxtEqLeft  eqρ₀ ▻Cong eqσ₀)
            (substEqCtxtEqRight eqρ₀ ▻Cong substTyCong eqσ₀ eqρ₀)
            (proof eqρ₀ (substEqToExtEq eqρ₀) eqσ₀)
    where
    proof (Γ¹, Δ¹ : Ctxt) (σ¹ : Ty Γ¹) (ρ¹ : Subst Γ¹ Δ¹)
          (Γ², Δ² : Ctxt) (σ² : Ty Γ²) (ρ² : Subst Γ² Δ²)
      : ρ¹ ≘ ρ² -> ρ¹ /≘/ ρ² -> σ¹ ≛ σ² -> ExtEq (ρ¹ ↑ σ¹) (ρ² ↑ σ²)
    proof {Γ¹} {Δ¹} {σ¹} {ρ¹} {Γ²} {Δ²} {σ²} {ρ²}
          eqρ (extEq eqΓ eqΔ _) eqσ _ (vz σ¹) _ (vz σ²) (vzCong _) =
      betweenTm (substVzLift σ¹ ρ¹) (substVzLift σ² ρ²) $
        varCong $ vzCong $ substTyCong eqσ eqρ
    proof {Γ¹} {Δ¹} {σ¹} {ρ¹} {Γ²} {Δ²} {σ²} {ρ²}
          eqρ (extEq eqΓ eqΔ proof') eqσ _ (vs v¹ σ¹) _ (vs v² σ²)
          (vsCong eqv _) =
      betweenTm (substVsLift v¹ σ¹ ρ¹) (substVsLift v² σ² ρ²) $
        substTmCong (proof' _ _ _ _ eqv)
                    (wkCong' eqΔ $ substTyCong eqσ eqρ)
    proof {Γ¹} {Δ¹} {σ¹} {ρ¹} {Γ²} {Δ²} {σ²} {ρ²}
          eqρ eqρ' eqσ _ (v¹ ∷≡∋ eqτ) _ v² (castVarEqˡ eqτ eqv) =
      substCastVar v¹ eqτ (ρ¹ ↑ σ¹)
        `transTm`
      proof eqρ eqρ' eqσ _ v¹ _ v² eqv
    proof {Γ¹} {Δ¹} {σ¹} {ρ¹} {Γ²} {Δ²} {σ²} {ρ²}
          eqρ eqρ' eqσ _ v¹ _ (v² ∷≡∋ eqτ) (castVarEqʳ eqτ eqv) =
      proof eqρ eqρ' eqσ _ v¹ _ v² eqv
        `transTm`
      symTm (substCastVar v² eqτ (ρ² ↑ σ²))

  substTyCong (Γ¹, Δ¹ : Ctxt) (τ¹ : Ty Γ¹) (ρ¹ : Subst Γ¹ Δ¹)
              (Γ², Δ² : Ctxt) (τ² : Ty Γ²) (ρ² : Subst Γ² Δ²)
    : τ¹ ≛ τ² -> ρ¹ ≘ ρ² -> τ¹ / ρ¹ ≛ τ² / ρ²
  substTyCong (✶Cong eqΓ)       eqρ = ✶Cong (substEqCtxtEqRight eqρ)
  substTyCong (ElCong eqt)      eqρ = ElCong (substTmCong eqt eqρ)
  substTyCong (ΠCong eqτ₁ eqτ₂) eqρ =
    ΠCong (substTyCong eqτ₁ eqρ) (substTyCong eqτ₂ (liftCong eqρ eqτ₁))

abstract

  idCong (Γ¹, Γ² : Ctxt)
    : Γ¹ ≜ Γ² -> id Γ¹ ≘ id Γ²
  idCong eqΓ = extEqToSubstEq $
    extEq eqΓ eqΓ
          (\σ¹ v¹ σ² v² eqv ->
              betweenTm (idVanishesTm (var v¹))
                        (idVanishesTm (var v²)) $
                varCong eqv)

  compCong (Γ¹, Δ¹, X¹ : Ctxt)
           (Γ², Δ², X² : Ctxt)
           (ρ₁¹ : Subst Γ¹ Δ¹) (ρ₂¹ : Subst Δ¹ X¹)
           (ρ₁² : Subst Γ² Δ²) (ρ₂² : Subst Δ² X²)
    : ρ₁¹ ≘ ρ₁² -> ρ₂¹ ≘ ρ₂² -> ρ₁¹ ⊙ ρ₂¹ ≘ ρ₁² ⊙ ρ₂²
  compCong {Γ¹} {Δ¹} {X¹} {Γ²} {Δ²} {X²} {ρ₁¹} {ρ₂¹} {ρ₁²} {ρ₂²}
           eqρ₁ eqρ₂ =
    extEqToSubstEq $
      extEq (substEqCtxtEqLeft  eqρ₁)
            (substEqCtxtEqRight eqρ₂)
            (\σ¹ v¹ σ² v² eqv ->
                betweenTm (compSplitsTm (var v¹) ρ₁¹ ρ₂¹)
                          (compSplitsTm (var v²) ρ₁² ρ₂²) $
                  substTmCong
                    (extEqProof eqv (substEqToExtEq eqρ₁))
                    eqρ₂)

------------------------------------------------------------------------
-- Identity vanishes for types as well

mutual

  idVanishesTy (Γ : Ctxt) : (τ : Ty Γ) -> τ / id Γ ≛ τ
  idVanishesTy     (✶ Γ)     = ✶Cong (reflCtxt Γ)
  idVanishesTy     (El t)    = ElCong (idVanishesTm t)
  idVanishesTy {Γ} (Π τ₁ τ₂) =
    ΠCong eq₁ (substTyCong (reflTy τ₂) (idLiftIsId τ₁)
                 `transTy`
               idVanishesTy τ₂)
    where eq₁ = idVanishesTy τ₁

  idLiftIsId (Γ : Ctxt)
    : (σ : Ty Γ) -> id Γ ↑ σ ≘ id (Γ ▻ σ)
  idLiftIsId {Γ} σ = extEqToSubstEq $
    extEqˡ⁼ (reflCtxt Γ ▻Cong idVanishesTy σ) (\_ v -> proof v)
    where
    proof (τ : Ty (Γ ▻ σ))
      : (v : Γ ▻ σ ∋ τ) -> var v /⊢ id Γ ↑ σ ≈⊢ var v /⊢ id (Γ ▻ σ)
    proof (vz σ) =
      substVzLift σ (id Γ)
        `transTm`
      varCong (vzCong $ idVanishesTy σ)
        `transTm`
      symTm (idVanishesTm (var $ vz σ))
    proof (vs v σ) =
      substVsLift v σ (id Γ)
        `transTm`
      substTmCong (idVanishesTm (var v))
                  (wkCong' (reflCtxt Γ) $ idVanishesTy σ)
        `transTm`
      substWk v σ
        `transTm`
      symTm (idVanishesTm (var $ vs v σ))
    proof (v ∷≡∋ eqτ) =
      betweenTm (substCastVar v eqτ (id Γ ↑ σ))
                (substCastVar v eqτ (id (Γ ▻ σ))) $
        proof v

------------------------------------------------------------------------
-- Weakening commutes

abstract

  wkCommutes (Γ, Δ : Ctxt)
    : (σ : Ty Γ) -> (ρ : Subst Γ Δ) -> wk σ ⊙ (ρ ↑ σ) ≘ ρ ⊙ wk (σ / ρ)
  wkCommutes σ ρ = extEqToSubstEq $ extEq⁼ $ \_ v ->
    compSplitsTm (var v) (wk σ) (ρ ↑ σ)
      `transTm`
    substTmCong (substWk v σ) (reflSubst (ρ ↑ σ))
      `transTm`
    substVsLift v σ ρ
      `transTm`
    symTm (compSplitsTm (var v) ρ (wk (σ / ρ)))

  wkCommutesTm (Γ, Δ : Ctxt) (τ : Ty Γ)
    : (t : Γ ⊢ τ) -> (σ : Ty Γ) -> (ρ : Subst Γ Δ)
    -> t /⊢ wk σ /⊢ ρ ↑ σ ≈⊢ t /⊢ ρ /⊢ wk (σ / ρ)
  wkCommutesTm t σ ρ =
    symTm (compSplitsTm t (wk σ) (ρ ↑ σ))
      `transTm`
    substTmCong (reflTm t) (wkCommutes σ ρ)
      `transTm`
    compSplitsTm t ρ (wk (σ / ρ))

------------------------------------------------------------------------
-- Composition splits for types as well

mutual

  compSplitsTy (Γ, Δ, X : Ctxt)
    :  (τ : Ty Γ) -> (ρ₁ : Subst Γ Δ) -> (ρ₂ : Subst Δ X)
    -> τ / ρ₁ ⊙ ρ₂ ≛ τ / ρ₁ / ρ₂
  compSplitsTy {Γ} {Δ} {X} (✶ Γ)     ρ₁ ρ₂ = ✶Cong (reflCtxt X)
  compSplitsTy {Γ} {Δ} {X} (Π τ₁ τ₂) ρ₁ ρ₂ =
    ΠCong eq₁
          (substTyCong (reflTy τ₂) (compLiftIsComp ρ₁ ρ₂ τ₁)
             `transTy`
           compSplitsTy τ₂ (ρ₁ ↑ τ₁) (ρ₂ ↑ (τ₁ / ρ₁)))
    where eq₁ = compSplitsTy τ₁ ρ₁ ρ₂
  compSplitsTy (El t) ρ₁ ρ₂ = ElCong (compSplitsTm t ρ₁ ρ₂)

  compLiftIsComp (Γ, Δ, X : Ctxt)
    :  (ρ₁ : Subst Γ Δ) -> (ρ₂ : Subst Δ X) -> (σ : Ty Γ)
    -> ρ₁ ⊙ ρ₂ ↑ σ ≘ (ρ₁ ↑ σ) ⊙ (ρ₂ ↑ (σ / ρ₁))
  compLiftIsComp {Γ₀} {Δ₀} {X₀} ρ₁₀ ρ₂₀ σ₀ = extEqToSubstEq $
    extEqˡ⁼ (reflCtxt X₀ ▻Cong compSplitsTy σ₀ ρ₁₀ ρ₂₀)
            (\τ v -> proof {Γ₀} {Δ₀} {X₀} {σ₀} {τ} v ρ₁₀ ρ₂₀)
    where
    proof (Γ, Δ, X : Ctxt) (σ : Ty Γ) (τ : Ty (Γ ▻ σ))
      :  (v : Γ ▻ σ ∋ τ) -> (ρ₁ : Subst Γ Δ) -> (ρ₂ : Subst Δ X)
      -> var v /⊢ ρ₁ ⊙ ρ₂ ↑ σ ≈⊢ var v /⊢ (ρ₁ ↑ σ) ⊙ (ρ₂ ↑ (σ / ρ₁))
    proof {Γ} {Δ} {X} {σ} (vz σ) ρ₁ ρ₂ =
      substVzLift σ (ρ₁ ⊙ ρ₂)
        `transTm`
      varCong (vzCong $ compSplitsTy σ ρ₁ ρ₂)
        `transTm`
      symTm (substVzLift (σ / ρ₁) ρ₂)
        `transTm`
      substTmCong (symTm $ substVzLift σ ρ₁) (reflSubst (ρ₂ ↑ (σ / ρ₁)))
        `transTm`
      symTm (compSplitsTm (var (vz σ)) (ρ₁ ↑ σ) (ρ₂ ↑ (σ / ρ₁)))
    proof {Γ} {Δ} {X} {σ} (vs v σ) ρ₁ ρ₂ =
      substVsLift v σ (ρ₁ ⊙ ρ₂)
        `transTm`
      substTmCong (compSplitsTm (var v) ρ₁ ρ₂)
                  (wkCong' (reflCtxt X) $ compSplitsTy σ ρ₁ ρ₂)
        `transTm`
      symTm (wkCommutesTm (var v /⊢ ρ₁) (σ / ρ₁) ρ₂)
        `transTm`
      substTmCong (symTm $ substVsLift v σ ρ₁)
                  (reflSubst (ρ₂ ↑ (σ / ρ₁)))
        `transTm`
      symTm (compSplitsTm (var (vs v σ)) (ρ₁ ↑ σ) (ρ₂ ↑ (σ / ρ₁)))
    proof {Γ} {Δ} {X} {σ} (v ∷≡∋ eqτ) ρ₁ ρ₂ =
      betweenTm (substCastVar v eqτ ((ρ₁ ⊙ ρ₂) ↑ σ))
                (substCastVar v eqτ ((ρ₁ ↑ σ) ⊙ (ρ₂ ↑ (σ / ρ₁)))) $
        proof {Γ} {Δ} {X} {σ} v ρ₁ ρ₂

------------------------------------------------------------------------
-- More substitution lemmas

abstract

  wkCommutesTy (Γ, Δ : Ctxt)
    : (τ, σ : Ty Γ) -> (ρ : Subst Γ Δ)
    -> τ / wk σ / ρ ↑ σ ≛ τ / ρ / wk (σ / ρ)
  wkCommutesTy τ σ ρ =
    symTy (compSplitsTy τ (wk σ) (ρ ↑ σ))
      `transTy`
    substTyCong (reflTy τ) (wkCommutes σ ρ)
      `transTy`
    compSplitsTy τ ρ (wk (σ / ρ))

  wkSubVanishes (Γ : Ctxt) (σ : Ty Γ)
    : (t : Γ ⊢ σ) -> wk σ ⊙ sub t ≘ id Γ
  wkSubVanishes {Γ} {σ} t = extEqToSubstEq $ extEq⁼ $ \_ v ->
    compSplitsTm (var v) (wk σ) (sub t)
      `transTm`
    substTmCong (substWk v σ) (reflSubst $ sub t)
      `transTm`
    substVsSub v σ t
      `transTm`
    symTm (idVanishesTm (var v))

  wkSubVanishesTy (Γ : Ctxt) (σ : Ty Γ)
    :  (τ : Ty Γ) -> (t : Γ ⊢ σ)
    -> τ / wk σ / sub t ≛ τ
  wkSubVanishesTy {Γ} {σ} τ t =
    symTy (compSplitsTy τ (wk σ) (sub t))
      `transTy`
    substTyCong (reflTy τ) (wkSubVanishes t)
      `transTy`
    idVanishesTy τ

  wkSubVanishesTm (Γ : Ctxt) (σ, τ : Ty Γ)
    :  (t : Γ ⊢ τ) -> (t' : Γ ⊢ σ)
    -> t /⊢ wk σ /⊢ sub t' ≈⊢ t
  wkSubVanishesTm {Γ} {σ} t t' =
    symTm (compSplitsTm t (wk σ) (sub t'))
      `transTm`
    substTmCong (reflTm t) (wkSubVanishes t')
      `transTm`
    idVanishesTm t

  subCommutes (Γ, Δ : Ctxt) (σ : Ty Γ)
    :  (t : Γ ⊢ σ) -> (ρ : Subst Γ Δ)
    -> sub t ⊙ ρ ≘ (ρ ↑ σ) ⊙ sub (t /⊢ ρ)
  subCommutes t₀ ρ₀ = extEqToSubstEq $ extEq⁼ (\_ -> proof _ _ t₀ ρ₀)
    where
    proof (Γ, Δ : Ctxt)
      :  (σ : Ty Γ) -> (τ : Ty (Γ ▻ σ))
      -> (t : Γ ⊢ σ) -> (ρ : Subst Γ Δ) -> (v : Γ ▻ σ ∋ τ)
      -> var v /⊢ sub t ⊙ ρ ≈⊢ var v /⊢ (ρ ↑ σ) ⊙ sub (t /⊢ ρ)
    proof σ _ t ρ (vz σ) =
      compSplitsTm (var (vz σ)) (sub t) ρ
        `transTm`
      substTmCong (substVzSub σ t) (reflSubst ρ)
        `transTm`
      symTm (substVzSub (σ / ρ) (t /⊢ ρ))
        `transTm`
      symTm (substTmCong (substVzLift σ ρ) (reflSubst (sub (t /⊢ ρ))))
        `transTm`
      symTm (compSplitsTm (var (vz σ)) (ρ ↑ σ) (sub (t /⊢ ρ)))
    proof σ _ t ρ (vs v σ) =
      compSplitsTm (var (vs v σ)) (sub t) ρ
        `transTm`
      substTmCong (substVsSub v σ t) (reflSubst ρ)
        `transTm`
      symTm (wkSubVanishesTm (var v /⊢ ρ) (t /⊢ ρ))
        `transTm`
      symTm (substTmCong (substVsLift v σ ρ) (reflSubst (sub (t /⊢ ρ))))
        `transTm`
      symTm (compSplitsTm (var (vs v σ)) (ρ ↑ σ) (sub (t /⊢ ρ)))
    proof σ _ t ρ (v ∷≡∋ eqτ) =
      betweenTm (substCastVar v eqτ (sub t ⊙ ρ))
                (substCastVar v eqτ ((ρ ↑ σ) ⊙ sub (t /⊢ ρ))) $
        proof σ _ t ρ v

  subCommutesTy (Γ, Δ : Ctxt) (σ : Ty Γ)
    :  (τ : Ty (Γ ▻ σ)) -> (t : Γ ⊢ σ) -> (ρ : Subst Γ Δ)
    -> τ / sub t / ρ ≛ τ / ρ ↑ σ / sub (t /⊢ ρ)
  subCommutesTy {Γ} {Δ} {σ} τ t ρ =
    symTy (compSplitsTy τ (sub t) ρ)
      `transTy`
    substTyCong (reflTy τ) (subCommutes t ρ)
      `transTy`
    compSplitsTy τ (ρ ↑ σ) (sub (t /⊢ ρ))

  -- The substitution (wk σ ↑ σ) ⊙ sub (var (vz σ)) creates a fresh
  -- variable one, and then substitutes this variable, the new
  -- variable zero, for the old variable zero. Hence the name of this
  -- lemma.

  subVzWithVz (Γ : Ctxt)
    : (σ : Ty Γ) -> (wk σ ↑ σ) ⊙ sub (var (vz σ)) ≘ id (Γ ▻ σ)
  subVzWithVz σ₀ = extEqToSubstEq $ extEq⁼ (\_ v -> proof σ₀ _ v)
    where
    proof (Γ : Ctxt)
      :  (σ : Ty Γ) -> (τ : Ty (Γ ▻ σ)) -> (v : Γ ▻ σ ∋ τ)
      -> var v /⊢ (wk σ ↑ σ) ⊙ sub (var (vz σ)) ≈⊢ var v /⊢ id (Γ ▻ σ)
    proof σ _ (vz σ)   =
      compSplitsTm (var (vz σ)) (wk σ ↑ σ) (sub (var (vz σ)))
        `transTm`
      substTmCong (substVzLift σ (wk σ)) (reflSubst (sub (var (vz σ))))
        `transTm`
      substVzSub (σ / wk σ) (var (vz σ))
        `transTm`
      symTm (idVanishesTm (var (vz σ)))
    proof σ _ (vs v σ) =
      compSplitsTm (var (vs v σ)) (wk σ ↑ σ) (sub (var (vz σ)))
        `transTm`
      substTmCong (substVsLift v σ (wk σ))
                  (reflSubst (sub (var (vz σ))))
        `transTm`
      wkSubVanishesTm (var v /⊢ wk σ) (var (vz σ))
        `transTm`
      substWk v σ
        `transTm`
      symTm (idVanishesTm (var (vs v σ)))
    proof {Γ} σ _ (v ∷≡∋ eqτ) =
      betweenTm (substCastVar v eqτ ((wk σ ↑ σ) ⊙ sub (var (vz σ))))
                (substCastVar v eqτ (id (Γ ▻ σ))) $
        proof σ _ v

  subVzWithVzTy (Γ : Ctxt) (σ : Ty Γ)
    : (τ : Ty (Γ ▻ σ)) -> τ / wk σ ↑ σ / sub (var (vz σ)) ≛ τ
  subVzWithVzTy {Γ} {σ} τ =
    symTy (compSplitsTy τ (wk σ ↑ σ) (sub (var (vz σ))))
      `transTy`
    substTyCong (reflTy τ) (subVzWithVz σ)
      `transTy`
    idVanishesTy τ

  idRightUnit (Γ, Δ : Ctxt)
    : (ρ : Subst Γ Δ) -> ρ ⊙ id Δ ≘ ρ
  idRightUnit {Γ} {Δ} ρ =
    extEqToSubstEq $ extEq⁼ $ \_ v ->
      compSplitsTm (var v) ρ (id Δ)
        `transTm`
      idVanishesTm (var v /⊢ ρ)

  idLeftUnit (Γ, Δ : Ctxt)
    : (ρ : Subst Γ Δ) -> id Γ ⊙ ρ ≘ ρ
  idLeftUnit {Γ} ρ =
    extEqToSubstEq $ extEq⁼ $ \_ v ->
      compSplitsTm (var v) (id Γ) ρ
        `transTm`
      substTmCong (idVanishesTm (var v)) (reflSubst ρ)

  compAssoc (Γ, Δ, X, Ξ : Ctxt)
    :  (ρ₁ : Subst Γ Δ) -> (ρ₂ : Subst Δ X) -> (ρ₃ : Subst X Ξ)
    -> ρ₁ ⊙ (ρ₂ ⊙ ρ₃) ≘ (ρ₁ ⊙ ρ₂) ⊙ ρ₃
  compAssoc {Γ} {Δ} {X} {Ξ} ρ₁ ρ₂ ρ₃ = extEqToSubstEq $ extEq⁼ $ \_ v ->
    compSplitsTm (var v) ρ₁ (ρ₂ ⊙ ρ₃)
      `transTm`
    compSplitsTm (var v /⊢ ρ₁) ρ₂ ρ₃
      `transTm`
    substTmCong (symTm (compSplitsTm (var v) ρ₁ ρ₂)) (reflSubst ρ₃)
      `transTm`
    symTm (compSplitsTm (var v) (ρ₁ ⊙ ρ₂) ρ₃)
