------------------------------------------------------------------------
-- Converting things with explicit substitutions to things without
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import TmVar

mutual

  tyToTy⁻ (Γ : Ctxt) : (τ : Ty Γ) -> Ty⁻ τ
  tyToTy⁻ (✶ Γ)     = ✶⁻ Γ
  tyToTy⁻ (Π τ₁ τ₂) = Π⁻ (tyToTy⁻ τ₁) (tyToTy⁻ τ₂)
  tyToTy⁻ (El t)    = El⁻ (tmToTm⁻ t)

  tmToTm⁻ (Γ : Ctxt) (τ : Ty Γ) : (t : Γ ⊢ τ) -> Tm⁻ Term t
  tmToTm⁻ (var v)        = var⁻ Term v
  tmToTm⁻ (λ {_} {τ₁} t) = λ⁻ (tyToTy⁻ τ₁) (tmToTm⁻ t)
  tmToTm⁻ (t₁ @ t₂)      = tmToTm⁻ t₁ @⁻ tmToTm⁻ t₂
  tmToTm⁻ (t ∷≡⊢ eqτ)    = tmToTm⁻ t ∷≛≡⊢⁻ eqτ
  tmToTm⁻ (t /⊢ ρ)       = tmToTm⁻ t /⊢⁻ substToSubst⁻ ρ

  substToSubst⁻ (Γ, Δ : Ctxt)
    : (ρ : Subst Γ Δ) -> Subst⁻ Term ρ
  substToSubst⁻ (wk σ)    = wk⁻ Term σ
  substToSubst⁻ (sub t)   = sub⁻ (tmToTm⁻ t)
  substToSubst⁻ (ρ ↑ σ)   = substToSubst⁻ ρ ↑⁻ σ
  substToSubst⁻ (id Γ)    = id⁻ Term Γ
  substToSubst⁻ (ρ₁ ⊙ ρ₂) = substToSubst⁻ ρ₁ ⊙⁻ substToSubst⁻ ρ₂

Implicit-FromExplicit : Type
Implicit-FromExplicit = time-plugin(Implicit-FromExplicit, Set)
