------------------------------------------------------------------------
-- Compositions split
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import Implicit.SubstitutionLemmas.StructuralCong
-- # import Implicit.SubstitutionLemmas.SimpleLemmas
-- # import Implicit.SubstitutionLemmas.IdVanishes
-- # import EqKind
-- # import TmVar

abstract

  compSplitsVar⁻ (k : EqKind) (tv₁, tv₂ : TmVar)
                 (Γ, Δ, X : Ctxt) (τ : Ty Γ)
                 (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
    :  (v : Γ ∋ τ) -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
    -> Tm⁻Eq k (v /∋⁻ ρ⁻₁ ⊙⁻ ρ⁻₂) (v /∋⁻ ρ⁻₁ /⊢⁻ ρ⁻₂)
  compSplitsVar⁻ v (ρ₁ ∷≡⇒⁻ eqρ) ρ₂ =
    castTm⁻Cong _ _ (compSplitsVar⁻ v ρ₁ ρ₂)
  compSplitsVar⁻ (vz σ) (ρ₁ ▷⁻ t⁻) ρ₂ =
    castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
                  `transTm⁻` castTm⁻Eq _ _
      `transTm⁻`
    symTm⁻ (castTm⁻Eq _ _)
  compSplitsVar⁻ (vs v σ) (ρ₁ ▷⁻ t⁻) ρ₂ =
    betweenTm⁻ (castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _)
               (castTm⁻Eq _ _) $
      compSplitsVar⁻ v ρ₁ ρ₂
  compSplitsVar⁻ (v ∷≡∋ eqτ) ρ₁ ρ₂ =
    betweenTm⁻ (substCastVar⁻ v eqτ (ρ₁ ⊙⁻ ρ₂))
               (substTm⁻Congˢ (substCastVar⁻ v eqτ ρ₁)
                              (reflSubst⁻ ρ₂)) $
      compSplitsVar⁻ v ρ₁ ρ₂

  wk⁻Commutes (k : EqKind) (tv₂ : TmVar)
              (Γ, Δ : Ctxt) (ρ : Subst Γ Δ)
    :  (tv₁ : TmVar) -> (σ : Ty Γ) -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> Subst⁻Eq k (wk⁻ tv₁ σ ⊙⁻ (ρ⁻ ↑⁻ σ)) (ρ⁻ ⊙⁻ wk⁻ tv₁ (σ / ρ))
  wk⁻Commutes tv₁ σ ρ =
    extEq⁻⁼ (wk⁻ _ _ ⊙⁻ (_ ↑⁻ _)) (_ ⊙⁻ wk⁻ _ _) $ \_ v ->
      compSplitsVar⁻ v (wk⁻ _ σ) (ρ ↑⁻ σ)
        `transTm⁻`
      substTm⁻Congˢ (substVar⁻Wk _ v σ) (reflSubst⁻ (ρ ↑⁻ σ))
        `transTm⁻`
      Tm⁻⊔Eq _ _
        `transTm⁻`
      substVar⁻VsLift v σ ρ tv₁
        `transTm⁻`
      symTm⁻ (compSplitsVar⁻ v ρ (wk⁻ _ (σ / _)))

  wk⁻CommutesTm⁻Var (k : EqKind) (tv₂ : TmVar)
                      (Γ, Δ : Ctxt) (τ : Ty Γ)
                      (t : Γ ⊢ τ) (ρ : Subst Γ Δ)
    :  (t⁻ : Tm⁻ Var t) -> (tv₁ : TmVar) -> (σ : Ty Γ)
    -> (ρ⁻ : Subst⁻ tv₂ ρ)
    -> Tm⁻Eq k (t⁻ /⊢⁻ wk⁻ tv₁ σ /⊢⁻ ρ⁻ ↑⁻ σ)
               (t⁻ /⊢⁻ ρ⁻ /⊢⁻ wk⁻ tv₁ (σ / ρ))
  wk⁻CommutesTm⁻Var (var⁻ Var v) tv₁ σ ρ⁻ =
    betweenTm⁻ (symTm⁻ (compSplitsVar⁻ v (wk⁻ tv₁ σ) (ρ⁻ ↑⁻ σ)))
               (symTm⁻ (compSplitsVar⁻ _ _ _)) $
      substVar⁻Cong (reflVar v) (wk⁻Commutes tv₁ σ ρ⁻)
  wk⁻CommutesTm⁻Var (t⁻ ∷≡⊢⁻ eqt) tv₁ σ ρ⁻ =
    castTm⁻Cong _ _ $ wk⁻CommutesTm⁻Var t⁻ tv₁ σ ρ⁻

mutual

  -- This mutual block would not be structurally recursive (at least
  -- as far as I can tell) if Var was not structurally smaller than
  -- Term. The following lexicographic measure shows that the code is
  -- structurally recursive:
  --  1: The TmVar index for the substitution ρ⁻₁.
  --  2: The TmVar index for the substitution ρ⁻₂.
  --  3: The variable/term.

  compSplitsVar⁻ʳ (k : EqKind) (Γ, Δ, X : Ctxt)
                  (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
    :  (tv₁, tv₂ : TmVar)
    -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ')) -> (v : Γ ++ Γ' ∋ τ)
    -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
    -> Tm⁻Eq k (v /∋⁻ ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⋆⁻ Γ')
               (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁))
  compSplitsVar⁻ʳ = helper
    where
    abstract
      lemma (Γ, Δ : Ctxt) (ρ₁ : Subst Γ Δ)
            (X : Ctxt) (ρ₂ : Subst Δ X)
            (k : EqKind)
        :  (tv₁, tv₂ : TmVar) -> (Γ' : RCtxt Γ) -> (τ, σ : Ty (Γ ++ Γ'))
        -> (v : Γ ++ Γ' ∋ τ)
        -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
        -> Tm⁻Eq k
             (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ wk⁻ Var (σ / ρ₁ ↑⋆ Γ')
                               /⊢⁻ ρ⁻₂ ↑⋆⁻ ((Γ' ▻ʳ σ) /→ ρ₁))
             (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁)
                               /⊢⁻ wk⁻ Var (σ / ρ₁ ↑⋆ Γ'
                                              / ρ₂ ↑⋆ (Γ' /→ ρ₁)))
      lemma Var tv₂ Γ' _ σ v ρ⁻₁ ρ⁻₂ =
        wk⁻CommutesTm⁻Var (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ')
                            Var
                            (σ / _ ↑⋆ Γ')
                            (ρ⁻₂ ↑⋆⁻ (Γ' /→ _))
      -- If structural recursion was not important, then the following
      -- cases could be compressed to the following:
      --
      --   lemma (Term' Var refl) tv₂ Γ' _ σ v ρ⁻₁ ρ⁻₂ =
      --     wk⁻CommutesTm⁻ {tv₂}
      --                    (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ')
      --                    Var
      --                    (σ / _ ↑⋆ Γ')
      --                    (ρ⁻₂ ↑⋆⁻ (Γ' /→ _))
      --
      -- However, since I want the code to be structurally recursive I
      -- have duplicated the case (tv₂ ≡ Var and tv₂ ≡ Term) and
      -- inlined wk⁻CommutesTm⁻.
      lemma {_} {_} {ρ₁} (Term' Var refl) Var Γ' _ σ v ρ⁻₁ ρ⁻₂ =
        substTm⁻Congˢ (substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Cong $ reflTy τ))
                      (reflSubst⁻ $ ρ⁻ ↑⁻ τ)
          `transTm⁻`
        symTm⁻ (compSplitsTm⁻ {Var} {tv₃} t⁻ (wk⁻ Var τ) (ρ⁻ ↑⁻ τ))
          `transTm⁻`
        substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Commutes Var τ ρ⁻)
          `transTm⁻`
        compSplitsTm⁻ {tv₃} {Var} t⁻ ρ⁻ (wk⁻ Var (τ / _))
          `transTm⁻`
        substTm⁻Congˢ (reflTm⁻ $ t⁻ /⊢⁻ ρ⁻) (wk⁻Cong $ reflTy (τ / _))
        where
        tv₃ = Var
        t⁻ = v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ'
        τ = σ / ρ₁ ↑⋆ Γ'
        ρ⁻ = ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁)
      lemma {_} {_} {ρ₁} (Term' Var refl) (Term' Var refl)
            Γ' _ σ v ρ⁻₁ ρ⁻₂ =
        substTm⁻Congˢ (substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Cong $ reflTy τ))
                      (reflSubst⁻ $ ρ⁻ ↑⁻ τ)
          `transTm⁻`
        symTm⁻ (compSplitsTm⁻ {Var} {tv₃} t⁻ (wk⁻ Var τ) (ρ⁻ ↑⁻ τ))
          `transTm⁻`
        substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Commutes Var τ ρ⁻)
          `transTm⁻`
        compSplitsTm⁻ {tv₃} {Var} t⁻ ρ⁻ (wk⁻ Var (τ / _))
          `transTm⁻`
        substTm⁻Congˢ (reflTm⁻ $ t⁻ /⊢⁻ ρ⁻) (wk⁻Cong $ reflTy (τ / _))
        where
        tv₃ = Term' Var refl
        t⁻ = v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ'
        τ = σ / ρ₁ ↑⋆ Γ'
        ρ⁻ = ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁)

      helper (k : EqKind) (Γ, Δ, X : Ctxt)
             (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
        :  (tv₁, tv₂ : TmVar)
        -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ')) -> (v : Γ ++ Γ' ∋ τ)
        -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
        -> Tm⁻Eq k (v /∋⁻ ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⋆⁻ Γ')
                   (v /∋⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁))
      helper tv₁ tv₂ (εʳ _) _ v           ρ₁ ρ₂ = compSplitsVar⁻ v ρ₁ ρ₂
      helper tv₁ tv₂ Γ'     _ (v ∷≡∋ eqτ) ρ₁ ρ₂ =
        betweenTm⁻ (substCastVar⁻ v eqτ (ρ₁ ⊙⁻ ρ₂ ↑⋆⁻ Γ'))
                   (substTm⁻Congˢ (substCastVar⁻ v eqτ (ρ₁ ↑⋆⁻ Γ'))
                                  (reflSubst⁻ $ ρ₂ ↑⋆⁻ (Γ' /→ _))) $
          helper tv₁ tv₂ Γ' _ v ρ₁ ρ₂
      helper tv₁ tv₂ (Γ' ▻ʳ σ) _ (vz σ) ρ₁ ρ₂ =
        substVar⁻VzLift σ (ρ₁ ⊙⁻ ρ₂ ↑⋆⁻ Γ')
          `transTm⁻`
        var⁻Cong (vzCong $ compSplitsTyʳ Γ' σ _ _)
          `transTm⁻`
        symTm⁻ (substVar⁻VzLift (σ / _ ↑⋆ Γ') (ρ₂ ↑⋆⁻ (Γ' /→ _)))
          `transTm⁻`
        (symTm⁻ (Tm⁻⊔Eq _ _)
           `transTm⁻`
         symTm⁻ (substTm⁻Congˢ (substVar⁻VzLift σ (ρ₁ ↑⋆⁻ Γ'))
                               (reflSubst⁻ $ ρ₂ ↑⋆⁻ ((Γ' ▻ʳ σ) /→ _)))
        )
      helper tv₁ tv₂ (Γ' ▻ʳ σ) _ (vs v σ) ρ₁ ρ₂ =
        substVar⁻VsLift v σ (ρ₁ ⊙⁻ ρ₂ ↑⋆⁻ Γ') Var
          `transTm⁻`
        substTm⁻Congˢ (helper tv₁ tv₂ Γ' _ v ρ₁ ρ₂)
                      (wk⁻Cong (compSplitsTyʳ _ _ _ _))
          `transTm⁻`
        symTm⁻ (lemma tv₁ tv₂ Γ' _ σ v ρ₁ ρ₂)
          `transTm⁻`
        symTm⁻ (substTm⁻Congˢ (substVar⁻VsLift v σ (ρ₁ ↑⋆⁻ Γ') Var)
                              (reflSubst⁻ _))

  compSplitsTm⁻ʳ (k : EqKind) (tv : TmVar) (Γ, Δ, X : Ctxt)
                 (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
    :  (tv₁, tv₂ : TmVar)
    -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ')) -> (t : Γ ++ Γ' ⊢ τ)
    -> (t⁻ : Tm⁻ tv t) -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
    -> Tm⁻Eq k (t⁻ /⊢⁻ ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⋆⁻ Γ')
               (t⁻ /⊢⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁))
  compSplitsTm⁻ʳ = helper
    where
    abstract
      helper (k : EqKind) (tv : TmVar) (Γ, Δ, X : Ctxt)
             (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
        :  (tv₁, tv₂ : TmVar)
        -> (Γ' : RCtxt Γ) -> (τ : Ty (Γ ++ Γ')) -> (t : Γ ++ Γ' ⊢ τ)
        -> (t⁻ : Tm⁻ tv t)
        -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
        -> Tm⁻Eq k (t⁻ /⊢⁻ ρ⁻₁ ⊙⁻ ρ⁻₂ ↑⋆⁻ Γ')
                   (t⁻ /⊢⁻ ρ⁻₁ ↑⋆⁻ Γ' /⊢⁻ ρ⁻₂ ↑⋆⁻ (Γ' /→ ρ₁))
      helper tv₁ tv₂ Γ' _ _ (var⁻ tv v) ρ₁ ρ₂ =
        betweenTm⁻ (Tm⁻⊔Eq _ _)
                   (substTm⁻Congˢ (Tm⁻⊔Eq tv _) (reflSubst⁻ _)) $
          compSplitsVar⁻ʳ tv₁ tv₂ Γ' _ v ρ₁ ρ₂
      helper tv₁ tv₂ Γ' _ _ (λ⁻ _ t) ρ₁ ρ₂ =
        betweenTm⁻ (castTm⁻Eq _ _)
                   (castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _) $
          λ⁻Cong (helper tv₁ tv₂ (Γ' ▻ʳ _) _ _ t ρ₁ ρ₂)
      helper tv₁ tv₂ Γ' _ _ (t₁ @⁻ t₂) ρ₁ ρ₂ =
        betweenTm⁻ (castTm⁻Eq _ _)
                   (castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _) $
          app⁻Cong (helper tv₁ tv₂ Γ' _ _ t₁ ρ₁ ρ₂)
                   (helper tv₁ tv₂ Γ' _ _ t₂ ρ₁ ρ₂)
      helper tv₁ tv₂ Γ' _ _ (t ∷≡⊢⁻ eqt) ρ₁ ρ₂ =
        castTm⁻Cong _ _ $ helper tv₁ tv₂ Γ' _ _ t ρ₁ ρ₂

  compSplitsTm⁻ (tv₁, tv₂, tv : TmVar) (k : EqKind) (Γ, Δ, X : Ctxt)
                (τ : Ty Γ) (t : Γ ⊢ τ) (ρ₁ : Subst Γ Δ) (ρ₂ : Subst Δ X)
    :  (t⁻ : Tm⁻ tv t) -> (ρ⁻₁ : Subst⁻ tv₁ ρ₁) -> (ρ⁻₂ : Subst⁻ tv₂ ρ₂)
    -> Tm⁻Eq k (t⁻ /⊢⁻ ρ⁻₁ ⊙⁻ ρ⁻₂) (t⁻ /⊢⁻ ρ⁻₁ /⊢⁻ ρ⁻₂)
  compSplitsTm⁻ = compSplitsTm⁻ʳ _ _ (εʳ _) _ _

abstract

  wk⁻CommutesTm⁻ (tv₃, tv₁ : TmVar) (k : EqKind)
                 (Γ, Δ : Ctxt) (τ : Ty Γ)
                 (t : Γ ⊢ τ) (ρ : Subst Γ Δ)
    :  (t⁻ : Tm⁻ tv₁ t) -> (tv₂ : TmVar) -> (σ : Ty Γ)
    -> (ρ⁻ : Subst⁻ tv₃ ρ)
    -> Tm⁻Eq k (t⁻ /⊢⁻ wk⁻ tv₂ σ /⊢⁻ ρ⁻ ↑⁻ σ)
               (t⁻ /⊢⁻ ρ⁻ /⊢⁻ wk⁻ tv₂ (σ / ρ))
  wk⁻CommutesTm⁻ {tv₃} t⁻ tv₂ σ ρ⁻ =
    substTm⁻Congˢ (substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Cong $ reflTy σ))
                  (reflSubst⁻ $ ρ⁻ ↑⁻ σ)
      `transTm⁻`
    symTm⁻ (compSplitsTm⁻ {Var} {tv₃} t⁻ (wk⁻ Var σ) (ρ⁻ ↑⁻ σ))
      `transTm⁻`
    substTm⁻Congˢ (reflTm⁻ t⁻) (wk⁻Commutes Var σ ρ⁻)
      `transTm⁻`
    compSplitsTm⁻ {tv₃} {Var} t⁻ ρ⁻ (wk⁻ Var (σ / _))
      `transTm⁻`
    substTm⁻Congˢ (reflTm⁻ $ t⁻ /⊢⁻ ρ⁻) (wk⁻Cong $ reflTy (σ / _))

Implicit-SubstitutionLemmas-CompSplits : Type
Implicit-SubstitutionLemmas-CompSplits =
  time-plugin(Implicit-SubstitutionLemmas-CompSplits, Set)
