------------------------------------------------------------------------
-- weakCongˢ/substTm⁻Congˢ
------------------------------------------------------------------------

-- # import Explicit
-- # import Implicit.Terms
-- # import Implicit.Substitutions
-- # import Implicit.FromExplicit
-- # import Implicit.Equality
-- # import Implicit.Equivalence
-- # import Implicit.EqualityLemmas
-- # import Implicit.CastEq
-- # import Implicit.WeakeningCong
-- # import Implicit.Coercions
-- # import Implicit.Soundness
-- # import EqKind
-- # import TmVar

abstract

  weakVarCong : WeakeningCong₁ structural (weak Var)
  weakVarCong = weakeningCong $ \_ _ _ _ _ _ _ _ _ _ -> helper
    where
    helper (Γ¹ : Ctxt) (τ¹, σ¹ : Ty Γ¹)
           (t¹ : Γ¹ ⊢ τ¹) (t⁻¹ : Tm⁻ Var t¹)
           (Γ² : Ctxt) (τ², σ² : Ty Γ²)
           (t² : Γ² ⊢ τ²) (t⁻² : Tm⁻ Var t²)
      :  Tm⁻Eq structural t⁻¹ t⁻² -> σ¹ ≛ σ²
      -> Tm⁻Eq structural (applyWeakening (weak Var) t⁻¹ σ¹)
                          (applyWeakening (weak Var) t⁻² σ²)
    helper (var⁻Cong eqv) eqσ =
      castTm⁻Cong _ _ $ var⁻Cong $ vsCong eqv eqσ
    -- Note that the following case would have been trickier if the
    -- constructor had been castTm⁻Eq instead of castTm⁻Eqˡ.
    helper (castTm⁻Eqˡ eqt eqt⁻) eqσ =
      castTm⁻Eqˡ _ $ helper eqt⁻ eqσ
    helper (castTm⁻Eqʳ eqt eqt⁻) eqσ =
      castTm⁻Eqʳ _ $ helper eqt⁻ eqσ

  weakVarCongˢ₁₂₁ : WeakeningCong₁₂₁ structural (weak Var) (weak Var)
  weakVarCongˢ₁₂₁ = wCong₁To₁₂₁ weakVarCong

  substVar⁻Wk⇒' (k : EqKind) (tv : TmVar) (w : Weakening tv)
                (Γ, Δ : Ctxt) (ρ : Subst Γ Δ) (τ : Ty Γ)
    :  WeakeningCong₁ k w
    -> (v : Γ ∋ τ) -> (ρ⁻ : Subst⁻ tv ρ) -> (σ : Ty Δ)
    -> Tm⁻Eq k (v /∋⁻ wk⇒⁻' w ρ⁻ σ) (applyWeakening w (v /∋⁻ ρ⁻) σ)
  substVar⁻Wk⇒' wCong v (ρ ∷≡⇒⁻ eqρ) σ =
    castTm⁻Eqˡ _ (substVar⁻Wk⇒' wCong v ρ σ)
      `transTm⁻`
    applyWeakeningCong wCong (symTm⁻ $ castTm⁻Eq (v /∋⁻ ρ) _)
                             (reflTy σ)
  substVar⁻Wk⇒' wCong (vz τ) (ρ ▷⁻ t⁻) σ =
    castTm⁻Eqˡ _ $ castTm⁻Eqˡ _ $ castTm⁻Eqˡ _ $
      applyWeakeningCong wCong (symTm⁻ $ castTm⁻Eq t⁻ _)
                               (reflTy σ)
  substVar⁻Wk⇒' wCong (vs v τ) (ρ ▷⁻ t⁻) σ =
    castTm⁻Eqˡ _ (castTm⁻Eqˡ _ $ substVar⁻Wk⇒' wCong v ρ σ)
      `transTm⁻`
    applyWeakeningCong wCong (symTm⁻ $ castTm⁻Eq (v /∋⁻ ρ) _)
                             (reflTy σ)
  substVar⁻Wk⇒' wCong (v ∷≡∋ eqτ) ρ σ =
    betweenTm⁻ (substCastVar⁻ v eqτ _)
               (applyWeakeningCong wCong (substCastVar⁻ v eqτ _)
                                         (reflTy σ)) $
      substVar⁻Wk⇒' wCong v ρ σ

  wk⇒⁻'Cong (k : EqKind)
            (tv¹ : TmVar) (w¹ : Weakening tv¹) (Γ¹, Δ¹ : Ctxt)
            (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹) (σ¹ : Ty Δ¹)
            (tv² : TmVar) (w² : Weakening tv²) (Γ², Δ² : Ctxt)
            (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²) (σ² : Ty Δ²)
    :  WeakeningCong₁₂₁ k w¹ w²
    -> Subst⁻Eq k ρ⁻¹ ρ⁻² -> σ¹ ≛ σ²
    -> Subst⁻Eq k (wk⇒⁻' w¹ ρ⁻¹ σ¹) (wk⇒⁻' w² ρ⁻² σ²)
  wk⇒⁻'Cong wCong (extEq⁻ eqΓ eqΔ proof) eqσ =
    extEq⁻ eqΓ (eqΔ ▻Cong eqσ)
           (\_ v¹ _ v² eqv ->
               betweenTm⁻ (substVar⁻Wk⇒' (wCong₁₂₁ToL wCong) v¹ _ _)
                          (substVar⁻Wk⇒' (wCong₁₂₁ToR wCong) v² _ _) $
                 applyWeakeningCongˡʳ wCong (proof _ v¹ _ v² eqv) eqσ)

  lift⁻'Cong (k : EqKind)
             (tv¹ : TmVar) (w¹ : Weakening tv¹) (Γ¹, Δ¹ : Ctxt)
             (ρ¹ : Subst Γ¹ Δ¹) (ρ⁻¹ : Subst⁻ tv¹ ρ¹) (σ¹ : Ty Γ¹)
             (tv² : TmVar) (w² : Weakening tv²) (Γ², Δ² : Ctxt)
             (ρ² : Subst Γ² Δ²) (ρ⁻² : Subst⁻ tv² ρ²) (σ² : Ty Γ²)
    :  WeakeningCong₁₂₁ k w¹ w² -> Subst⁻Eq k ρ⁻¹ ρ⁻² -> σ¹ ≛ σ²
    -> Subst⁻Eq k (lift⁻' w¹ ρ⁻¹ σ¹) (lift⁻' w² ρ⁻² σ²)
  lift⁻'Cong wCong eqρ⁻ eqσ = castSubst⁻Cong _ _ $
    Cong▷⁻ (wk⇒⁻'Cong wCong eqρ⁻ eqσρ)
           eqσ
           (var⁻Cong (castVarCong _ _ $ vzCong eqσρ))
    where eqσρ = substTyCong eqσ (subst⁻EqSubstEq eqρ⁻)

  generalCastSubst⁻Cong (k : EqKind)
    (Γ₁¹, Δ₁¹ : Ctxt) (ρ₁¹ : Subst Γ₁¹ Δ₁¹)
    (Γ₂¹, Δ₂¹ : Ctxt) (ρ₂¹ : Subst Γ₂¹ Δ₂¹)
    (tv¹ : TmVar) (ρ⁻¹ : Subst⁻ tv¹ ρ₁¹)
    (Γ₁², Δ₁² : Ctxt) (ρ₁² : Subst Γ₁² Δ₁²)
    (Γ₂², Δ₂² : Ctxt) (ρ₂² : Subst Γ₂² Δ₂²)
    (tv² : TmVar) (ρ⁻² : Subst⁻ tv² ρ₁²)
    :  (eqρ¹ : ρ₁¹ ≘ ρ₂¹) -> (eqρ² : ρ₁² ≘ ρ₂²) -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> Subst⁻Eq k (ρ⁻¹ ∷⇒⁻ eqρ¹) (ρ⁻² ∷⇒⁻ eqρ²)
  generalCastSubst⁻Cong eqρ¹ eqρ² eqρ⁻ =
    betweenSubst⁻ (symSubst⁻ $ generalCastSubst⁻Eq _ eqρ¹)
                  (symSubst⁻ $ generalCastSubst⁻Eq _ eqρ²)
                  eqρ⁻

  id⁻'Cong (k : EqKind)
           (tv¹ : TmVar) (w¹ : Weakening tv¹) (Γ¹ : Ctxt)
           (tv² : TmVar) (w² : Weakening tv²) (Γ² : Ctxt)
    :  WeakeningCong₁₂₁ k w¹ w²
    -> Γ¹ ≜ Γ² -> Subst⁻Eq k (id⁻' w¹ Γ¹) (id⁻' w² Γ²)
  id⁻'Cong wCong εCong           = castSubst⁻Cong _ _ $ ∅⁻Cong _ _ εCong
  id⁻'Cong wCong (eqΓ ▻Cong eqσ) = generalCastSubst⁻Cong _ _ $
    lift⁻'Cong wCong (id⁻'Cong wCong eqΓ) eqσ

  wk⁻'Cong (k : EqKind)
           (tv¹ : TmVar) (w¹ : Weakening tv¹) (Γ¹ : Ctxt) (σ¹ : Ty Γ¹)
           (tv² : TmVar) (w² : Weakening tv²) (Γ² : Ctxt) (σ² : Ty Γ²)
    :  WeakeningCong₁₂₁ k w¹ w² -> σ¹ ≛ σ²
    -> Subst⁻Eq k (wk⁻' w¹ σ¹) (wk⁻' w² σ²)
  wk⁻'Cong wCong eqσ = castSubst⁻Cong _ _ $
    wk⇒⁻'Cong wCong (id⁻'Cong wCong $ tyEqCtxtEq eqσ) eqσ

  id⁻IsWkSnocVz' (k : EqKind) (tv : TmVar) (Γ : Ctxt)
    :  WeakeningCong₁ k (weak tv) -> (τ : Ty Γ)
    -> Subst⁻Eq k (id⁻ tv (Γ ▻ τ)) (wk⁻ tv τ ▷⁻ var⁻ tv (vz τ))
  id⁻IsWkSnocVz' wCong _ =
    symSubst⁻ (generalCastSubst⁻Eq _ _)
      `transSubst⁻`
    Cong▷⁻ (wk⇒⁻'Cong (wCong₁To₁₂₁ wCong)
                      (id⁻'Cong (wCong₁To₁₂₁ wCong) (reflCtxt _))
                      (idVanishesTy _)
              `transSubst⁻`
            symSubst⁻ (castSubst⁻Eq _ _))
           (reflTy _)
           (var⁻Cong $ castVarEqˡ _ $ vzCong $ idVanishesTy _)

mutual

  weakIsVs (tv : TmVar) (k : EqKind) (Γ : Ctxt) (τ : Ty Γ)
    :  (v : Γ ∋ τ) -> (σ : Ty Γ)
    -> Tm⁻Eq k (applyWeakening (weak tv) (var⁻ tv v) σ)
               (var⁻ tv (vs v σ))
  weakIsVs = helper
    where
    abstract
      -- Helper functions like this one are used since functions in
      -- mutual blocks cannot be abstract.
      helper (tv : TmVar) (k : EqKind) (Γ : Ctxt) (τ : Ty Γ)
        :  (v : Γ ∋ τ) -> (σ : Ty Γ)
        -> Tm⁻Eq k (applyWeakening (weak tv) (var⁻ tv v) σ)
                   (var⁻ tv (vs v σ))
      helper {Var}            v σ = castTm⁻Eq _ _
      helper {Term' Var refl} v σ = coerceFromTm⁻ $
        betweenTm⁻ (castTm⁻Eq _ _) (symTm⁻ $ castTm⁻Eq _ _) $
          Tm⁻⊔Cong Term Term
            (substVar⁻Wk⇒' weakVarCong v (id⁻' (weak Var) _) σ
               `transTm⁻`
             applyWeakeningCong weakVarCong
               (idVanishesVar⁻' weakVarCong v)
               (reflTy _))

  idVanishesVar⁻' (k : EqKind) (tv : TmVar) (Γ : Ctxt) (τ : Ty Γ)
    :  WeakeningCong₁ k (weak tv)
    -> (v : Γ ∋ τ) -> Tm⁻Eq k (v /∋⁻ id⁻ tv Γ) (var⁻ tv v)
  idVanishesVar⁻' = helper
    where
    abstract
      helper (k : EqKind) (tv : TmVar) (Γ : Ctxt) (τ : Ty Γ)
        :  WeakeningCong₁ k (weak tv)
        -> (v : Γ ∋ τ) -> Tm⁻Eq k (v /∋⁻ id⁻ tv Γ) (var⁻ tv v)
      helper wCong (vz σ) =
        substVar⁻Cong (reflVar $ vz σ) (id⁻IsWkSnocVz' wCong σ)
          `transTm⁻`
        castTm⁻Eq _ _
      helper wCong (vs v σ) =
        substVar⁻Cong (reflVar $ vs v σ) (id⁻IsWkSnocVz' wCong σ)
          `transTm⁻`
        castTm⁻Eq _ _ `transTm⁻` castTm⁻Eq _ _
          `transTm⁻`
        substVar⁻Wk⇒' wCong _ _ _
          `transTm⁻`
        applyWeakeningCong wCong (idVanishesVar⁻' wCong v) (reflTy _)
          `transTm⁻`
        weakIsVs v _
      helper wCong (v ∷≡∋ σ) =
        betweenTm⁻ (substCastVar⁻ _ _ _) (var⁻Cong $ castVarEq _ _) $
          idVanishesVar⁻' wCong v

abstract

  substTm⁻'Congˢ (k : EqKind)
                 (Γ¹, Δ¹ : Ctxt) (τ¹ : Ty Γ¹)
                 (ρ¹ : Subst Γ¹ Δ¹) (t¹ : Γ¹ ⊢ τ¹) (tv₁¹, tv₂¹ : TmVar)
                 (t⁻¹ : Tm⁻ tv₁¹ t¹) (ρ⁻¹ : Subst⁻ tv₂¹ ρ¹)
                 (Γ², Δ² : Ctxt) (τ² : Ty Γ²)
                 (ρ² : Subst Γ² Δ²) (t² : Γ² ⊢ τ²) (tv₁², tv₂² : TmVar)
                 (t⁻² : Tm⁻ tv₁² t²) (ρ⁻² : Subst⁻ tv₂² ρ²)
    :  WeakeningCong₁₂₁ k (weak tv₂¹) (weak tv₂²)
    -> Tm⁻Eq structural t⁻¹ t⁻² -> Subst⁻Eq k ρ⁻¹ ρ⁻²
    -> Tm⁻Eq k (t⁻¹ /⊢⁻ ρ⁻¹) (t⁻² /⊢⁻ ρ⁻²)
  substTm⁻'Congˢ wCong (var⁻Cong eqv) eqρ =
    Tm⁻⊔Cong _ _ (substVar⁻Cong eqv eqρ)
  substTm⁻'Congˢ wCong (λ⁻Cong eqt) eqρ =
    castTm⁻Cong _ _ $
      λ⁻Cong $ substTm⁻'Congˢ wCong eqt (lift⁻'Cong wCong eqρ eqτ₁)
    where eqτ₁ = snocEqLastEq $ tm⁻EqCtxtEq eqt
  substTm⁻'Congˢ wCong (app⁻Cong eqt₁ eqt₂)   eqρ =
    castTm⁻Cong _ _ (app⁻Cong (substTm⁻'Congˢ wCong eqt₁ eqρ)
                              (substTm⁻'Congˢ wCong eqt₂ eqρ))
  -- Note that with castTm⁻Eq as the constructor this case would have
  -- been harder to prove.
  substTm⁻'Congˢ wCong (castTm⁻Eqˡ eqt eqt⁻) eqρ =
    castTm⁻Eqˡ _ $ substTm⁻'Congˢ wCong eqt⁻ eqρ
  substTm⁻'Congˢ wCong (castTm⁻Eqʳ eqt eqt⁻) eqρ =
    castTm⁻Eqʳ _ $ substTm⁻'Congˢ wCong eqt⁻ eqρ

  weakIsSubst⁻Wk (k : EqKind) (Γ : Ctxt) (τ : Ty Γ) (t : Γ ⊢ τ)
    :  (tv : TmVar) -> WeakeningCong₁₂₁ k (weak Var) (weak tv)
    -> (t⁻ : Tm⁻ tv t) -> (σ : Ty Γ)
    -> Tm⁻Eq k (applyWeakening (weak tv) t⁻ σ) (t⁻ /⊢⁻ wk⁻ tv σ)
  weakIsSubst⁻Wk Var wCong (var⁻ Var v) σ = symTm⁻ $
    castTm⁻Eq _ _
      `transTm⁻`
    substVar⁻Wk⇒' (wCong₁₂₁ToR wCong) v (id⁻' weakVar _) σ
      `transTm⁻`
    applyWeakeningCongʳ wCong
      (idVanishesVar⁻' (wCong₁₂₁ToR wCong) v) (reflTy _)
  weakIsSubst⁻Wk Var wCong (t⁻ ∷≡⊢⁻ eqt) σ =
    castTm⁻Cong _ _ $ weakIsSubst⁻Wk Var wCong t⁻ σ
  weakIsSubst⁻Wk (Term' Var refl) wCong t σ =
    substTm⁻'Congˢ wCong (reflTm⁻ t) (wk⁻'Cong wCong $ reflTy σ)

  weakCong' (k : EqKind)
    :  (  (Γ¹, Δ¹ : Ctxt) -> (τ¹ : Ty Γ¹)
       -> (ρ¹ : Subst Γ¹ Δ¹) -> (t¹ : Γ¹ ⊢ τ¹)
       -> (ρ⁻¹ : Subst⁻ Var ρ¹) -> (tv¹ : TmVar) -> (t⁻¹ : Tm⁻ tv¹ t¹)
       -> (Γ², Δ² : Ctxt) -> (τ² : Ty Γ²)
       -> (ρ² : Subst Γ² Δ²) -> (t² : Γ² ⊢ τ²)
       -> (ρ⁻² : Subst⁻ Var ρ²) -> (tv² : TmVar) -> (t⁻² : Tm⁻ tv² t²)
       -> Tm⁻Eq k t⁻¹ t⁻² -> Subst⁻Eq structural ρ⁻¹ ρ⁻²
       -> Tm⁻Eq k (t⁻¹ /⊢⁻ ρ⁻¹) (t⁻² /⊢⁻ ρ⁻²))
    -> (tv¹, tv² : TmVar)
    -> WeakeningCong k (weak tv¹) (weak tv²)
  weakCong' {k} tsCong _ _ =
    weakeningCong $ \_ _ _ _ _ _ _ _ _ _ -> helper _ _ _ _
    where
    helper (Γ¹ : Ctxt) (τ¹, σ¹ : Ty Γ¹) (t¹ : Γ¹ ⊢ τ¹)
           (Γ² : Ctxt) (τ², σ² : Ty Γ²) (t² : Γ² ⊢ τ²)
      :  (tv¹, tv² : TmVar) -> (t⁻¹ : Tm⁻ tv¹ t¹) -> (t⁻² : Tm⁻ tv² t²)
      -> Tm⁻Eq k t⁻¹ t⁻² -> σ¹ ≛ σ²
      -> Tm⁻Eq k (applyWeakening (weak tv¹) t⁻¹ σ¹)
                 (applyWeakening (weak tv²) t⁻² σ²)
    helper Var Var t⁻¹ t⁻² eqt⁻ eqσ =
      coerceFromTm⁻ (weakIsSubst⁻Wk Var weakVarCongˢ₁₂₁ t⁻¹ _)
        `transTm⁻`
      tsCong _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
             eqt⁻ (wk⁻'Cong weakVarCongˢ₁₂₁ eqσ)
        `transTm⁻`
      coerceFromTm⁻ (symTm⁻ $ weakIsSubst⁻Wk Var weakVarCongˢ₁₂₁ t⁻² _)
    helper (Term' Var refl) (Term' Var refl) t⁻¹ t⁻² eqt⁻ eqσ =
      tsCong _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
             eqt⁻ (wk⁻'Cong weakVarCongˢ₁₂₁ eqσ)
    helper Var (Term' Var refl) t⁻¹ t⁻² eqt⁻ eqσ =
      coerceFromTm⁻ (weakIsSubst⁻Wk Var weakVarCongˢ₁₂₁ t⁻¹ _)
        `transTm⁻`
      tsCong _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _
             eqt⁻ (wk⁻'Cong weakVarCongˢ₁₂₁ eqσ)
    helper (Term' Var refl) Var t⁻¹ t⁻² eqt⁻ eqσ = symTm⁻ $
      helper Var (Term' Var refl) t⁻² t⁻¹ (symTm⁻ eqt⁻) (symTy eqσ)

  weakCongˢ
    :  (tv¹, tv² : TmVar)
    -> WeakeningCong structural (weak tv¹) (weak tv²)
  weakCongˢ = weakCong' $ \_ _ _ _ _ _ _ _ _ _ _ _ _ _ _ _ eqt eqρ ->
                             substTm⁻'Congˢ weakVarCongˢ₁₂₁ eqt eqρ

  weakCongˢ₁₂₁
    :  (tv¹, tv² : TmVar)
    -> WeakeningCong₁₂₁ structural (weak tv¹) (weak tv²)
  weakCongˢ₁₂₁ tv¹ tv² =
    weakeningCong₁₂₁ (weakCongˢ tv¹ tv¹)
                     (weakCongˢ tv¹ tv²)
                     (weakCongˢ tv² tv²)

  substTm⁻Congˢ (k : EqKind)
    (Γ¹, Δ¹ : Ctxt) (τ¹ : Ty Γ¹) (ρ¹ : Subst Γ¹ Δ¹) (t¹ : Γ¹ ⊢ τ¹)
    (tv₁¹, tv₂¹ : TmVar) (t⁻¹ : Tm⁻ tv₁¹ t¹) (ρ⁻¹ : Subst⁻ tv₂¹ ρ¹)
    (Γ², Δ² : Ctxt) (τ² : Ty Γ²) (ρ² : Subst Γ² Δ²) (t² : Γ² ⊢ τ²)
    (tv₁², tv₂² : TmVar) (t⁻² : Tm⁻ tv₁² t²) (ρ⁻² : Subst⁻ tv₂² ρ²)
    :  Tm⁻Eq structural t⁻¹ t⁻² -> Subst⁻Eq structural ρ⁻¹ ρ⁻²
    -> Tm⁻Eq k (t⁻¹ /⊢⁻ ρ⁻¹) (t⁻² /⊢⁻ ρ⁻²)
  substTm⁻Congˢ eqt⁻ eqρ = coerceFromTm⁻ $
    substTm⁻'Congˢ (weakCongˢ₁₂₁ _ _) eqt⁻ eqρ

Implicit-SubstitutionLemmas-StructuralCong : Type
Implicit-SubstitutionLemmas-StructuralCong =
  time-plugin(Implicit-SubstitutionLemmas-StructuralCong, Set)
